GET /_nodes/{node_id}/stats/{metric}/{index_metric}

All methods and paths for this operation:

GET /_nodes/stats

GET /_nodes/stats/{metric}
GET /_nodes/{node_id}/stats
GET /_nodes/{node_id}/stats/{metric}
GET /_nodes/stats/{metric}/{index_metric}
GET /_nodes/{node_id}/stats/{metric}/{index_metric}

Get statistics for nodes in a cluster. By default, all stats are returned. You can limit the returned information by using metrics.

Required authorization

  • Cluster privileges: monitor,manage

Path parameters

  • node_id string | array[string] Required

    Comma-separated list of node IDs or names used to limit returned information.

  • metric string | array[string]

    Limits the information returned to the specific metrics.

    Supported values include: _all, _none, indices, os, process, jvm, thread_pool, fs, transport, http, breaker, script, discovery, ingest, adaptive_selection, script_cache, indexing_pressure, repositories, allocations

    Values are _all, _none, indices, os, process, jvm, thread_pool, fs, transport, http, breaker, script, discovery, ingest, adaptive_selection, script_cache, indexing_pressure, repositories, or allocations.

  • index_metric string | array[string] Required

    Limit the information returned for indices metric to the specific index metrics. It can be used only if indices (or all) metric is specified.

    Supported values include:

    • _all: Return all statistics.
    • store: Size of the index in byte units.
    • indexing: Indexing statistics.
    • get: Get statistics, including missing stats.
    • search: Search statistics including suggest statistics. You can include statistics for custom groups by adding an extra groups parameter (search operations can be associated with one or more groups). The groups parameter accepts a comma-separated list of group names. Use _all to return statistics for all groups.
    • merge: Merge statistics.
    • flush: Flush statistics.
    • refresh: Refresh statistics.
    • query_cache: Query cache statistics.
    • fielddata: Fielddata statistics.
    • docs: Number of documents and deleted docs not yet merged out. Index refreshes can affect this statistic.
    • warmer: Index warming statistics.
    • completion: Completion suggester statistics.
    • segments: Memory use of all open segments. If the include_segment_file_sizes parameter is true, this metric includes the aggregated disk usage of each Lucene index file.
    • translog: Translog statistics.
    • request_cache: Shard request cache statistics.
    • recovery: Recovery statistics.
    • bulk: Bulk operations statistics.
    • shard_stats: Shard statistics, including the total number of shards.
    • mappings: Mapping statistics, including the total count and estimated overhead.
    • dense_vector: Total number of dense vectors indexed. Index refreshes can affect this statistic.
    • sparse_vector: Total number of sparse vectors indexed. Index refreshes can affect this statistic.

    Values are _all, store, indexing, get, search, merge, flush, refresh, query_cache, fielddata, docs, warmer, completion, segments, translog, request_cache, recovery, bulk, shard_stats, mappings, dense_vector, or sparse_vector.

Query parameters

  • completion_fields string | array[string]

    Comma-separated list or wildcard expressions of fields to include in fielddata and suggest statistics.

  • fielddata_fields string | array[string]

    Comma-separated list or wildcard expressions of fields to include in fielddata statistics.

  • fields string | array[string]

    Comma-separated list or wildcard expressions of fields to include in the statistics.

  • groups boolean

    Comma-separated list of search groups to include in the search statistics.

  • include_segment_file_sizes boolean

    If true, the call reports the aggregated disk usage of each one of the Lucene index files (only applies if segment stats are requested).

  • level string

    Indicates whether statistics are aggregated at the node, indices, or shards level.

    Values are node, indices, or shards.

  • timeout string

    Period to wait for a response. If no response is received before the timeout expires, the request fails and returns an error.

    External documentation
  • types array[string]

    A comma-separated list of document types for the indexing index metric.

  • include_unloaded_segments boolean

    If true, the response includes information from segments that are not loaded into memory.

Responses

  • 200 application/json
    Hide response attributes Show response attributes object
    • _nodes object

      Contains statistics about the number of nodes selected by the request’s node filters.

      Hide _nodes attributes Show _nodes attributes object
      • failures array[object]

        Cause and details about a request failure. This class defines the properties common to all error types. Additional details are also provided, that depend on the error type.

        Cause and details about a request failure. This class defines the properties common to all error types. Additional details are also provided, that depend on the error type.

      • total number Required

        Total number of nodes selected by the request.

      • successful number Required

        Number of nodes that responded successfully to the request.

      • failed number Required

        Number of nodes that rejected the request or failed to respond. If this value is not 0, a reason for the rejection or failure is included in the response.

    • cluster_name string
    • nodes object Required
      Hide nodes attribute Show nodes attribute object
      • * object Additional properties
        Hide * attributes Show * attributes object
        • adaptive_selection object

          Statistics about adaptive replica selection.

          Hide adaptive_selection attribute Show adaptive_selection attribute object
          • * object Additional properties
        • breakers object

          Statistics about the field data circuit breaker.

          Hide breakers attribute Show breakers attribute object
          • * object Additional properties
        • fs object

          File system information, data path, free disk space, read/write stats.

        • host string

          Network host for the node, based on the network host setting.

        • http object

          HTTP connection information.

        • ingest object

          Statistics about ingest preprocessing.

        • ip string | array[string]

          IP address and port for the node.

        • jvm object

          JVM stats, memory pool information, garbage collection, buffer pools, number of loaded/unloaded classes.

        • name string

          Human-readable identifier for the node. Based on the node name setting.

        • os object

          Operating system stats, load average, mem, swap.

        • process object

          Process statistics, memory consumption, cpu usage, open file descriptors.

        • roles array[string]

          Roles assigned to the node.

          Values are master, data, data_cold, data_content, data_frozen, data_hot, data_warm, client, ingest, ml, voting_only, transform, remote_cluster_client, or coordinating_only.

        • script object

          Contains script statistics for the node.

        • script_cache object
        • thread_pool object

          Statistics about each thread pool, including current size, queue and rejected tasks.

          Hide thread_pool attribute Show thread_pool attribute object
          • * object Additional properties
        • timestamp number
        • transport object

          Transport statistics about sent and received bytes in cluster communication.

        • transport_address string

          Host and port for the transport layer, used for internal communication between nodes in a cluster.

        • attributes object

          Contains a list of attributes for the node.

          Hide attributes attribute Show attributes attribute object
          • * string Additional properties
        • discovery object

          Contains node discovery statistics for the node.

        • indexing_pressure object

          Contains indexing pressure statistics for the node.

        • indices object

          Indices stats about size, document count, indexing and deletion times, search times, field cache size, merges and flushes.

GET /_nodes/{node_id}/stats/{metric}/{index_metric}
GET _nodes/stats/process?filter_path=**.max_file_descriptors
resp = client.nodes.stats(
    metric="process",
    filter_path="**.max_file_descriptors",
)
const response = await client.nodes.stats({
  metric: "process",
  filter_path: "**.max_file_descriptors",
});
response = client.nodes.stats(
  metric: "process",
  filter_path: "**.max_file_descriptors"
)
$resp = $client->nodes()->stats([
    "metric" => "process",
    "filter_path" => "**.max_file_descriptors",
]);
curl -X GET -H "Authorization: ApiKey $ELASTIC_API_KEY" "$ELASTICSEARCH_URL/_nodes/stats/process?filter_path=**.max_file_descriptors"
client.nodes().stats(s -> s
    .metric("process")
);